
/* PC1450 - A calculator emulator
 * Copyright (C) 1996 - 2001 Yves Maingoy
 * ymaingoy@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
    Emule.c
    Toutes les instructions assembleur du sharp sont emulees ici.
    v 0.02 03/11/1996 - 23/11/2001
*/

#include <stdio.h>
#include <conio.h>
#include "memory.h"
#include "emule.h"
#include "video.h"
#include "unassemble.h"

/* declaration des registres */
union SHARP_REGS ram;
char flags;
unsigned char P;
unsigned char Q;
unsigned char R;
unsigned char P;
unsigned char D;
unsigned char IA;
unsigned char IB;
unsigned char IC;
unsigned char IF;
unsigned short DP;
unsigned short PC;

extern void GestionKeyboard(void);


/* Emulation: */
unsigned char DTJcompter;
int KeybdTempo;
unsigned int breakPC; 		/* interruption du debugger */
int  is_mode_proceed = 0; 	/* !=0 si mode proceed */
int cycles;

/* sortie RS232 */
int IOByteOut=0;
int IOByteOutCpt = 0;
int isIOByteOut= 0;
int isFileNameOut =0;
int isFileNameIn =0;

FILE *fpOut;
FILE *fpIn;

/* calculs en DCB */

unsigned char dcbTableH[] = "\x00\x0A\x14\x1E\x28\x32\x3C\x46\x50\x5A\x00\x0A\x14\x1E\x28\x32";
unsigned char dcbTableByte[] = "\
\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\
\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\
\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\
\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\
\x40\x41\x42\x43\x44\x45\x46\x47\x48\x49\
\x50\x51\x52\x53\x54\x55\x56\x57\x58\x59\
\x60\x61\x62\x63\x64\x65\x66\x67\x68\x69\
\x70\x71\x72\x73\x74\x75\x76\x77\x78\x79\
\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\
\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\
\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\
\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\
\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\
\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\
\x40\x41\x42\x43\x44\x45\x46\x47\x48\x49\
\x50\x51\x52\x53\x54\x55\x56\x57\x58\x59\
\x60\x61\x62\x63\x64\x65\x66\x67\x68\x69\
\x70\x71\x72\x73\x74\x75\x76\x77\x78\x79\
\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\
\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\
\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\
\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\
\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\
\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\
\x40\x41\x42\x43\x44\x45\x46\x47\x48\x49\
\x50\x51\x52\x53\x54\x55";





void what()
{
    is_mode_proceed = 0;
}

void (*instructions[])()=
/*       0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F */
/* 0*/ {LII ,LIJ ,LIA ,LIB ,IX  ,DX  ,IY  ,DY  ,MVW ,EXW ,MVB ,EXB ,ADN ,SBN ,ADW ,SBW
/* 1*/ ,LIDP,LIDL,LIP ,LIQ ,ADB ,SBB ,INTx,what,MVWD,EXWD,MVBD,EXBD,SRW ,SLW ,FILM,FILD
/* 2*/ ,LDP ,LDQ ,LDR ,RA  ,IXL ,DXL ,IYS ,DYS ,JRNZP,JRNZM,JRNCP,JRNCM,JRP ,JRM ,what,LOOP
/* 3*/ ,STP ,STQ ,STR ,what,PUSH,DATA,what,RTN ,JRZP,JRZM,JRCP,JRCM,what,what,what,what
/* 4*/ ,INCI,DECI,INCA,DECA,ADM ,SBM ,ANMA,ORMA,INCK,DECK,INCM,DECM,INA ,NOPW,WAIT,WAITI
/* 5*/ ,INCP,DECP,STD ,MVDM,READA,MVMD,READM,LDD,SWP,LDM ,SL  ,POP ,what,OUTA,what,OUTF
/* 6*/ ,ANIM,ORIM,TSIM,CPIM,ANIA,ORIA,TSIA,CPIA,what,DTJ ,what,TEST,what,what,what,what
/* 7*/ ,ADIM,SBIM,RZ  ,RZ  ,ADIA,SBIA,RZ  ,RZ  ,CALL,JP  ,PTJ ,what,JPNZ,JPNC,JPZ ,JPC
/* 8*/ ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP
/* 9*/ ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP
/* A*/ ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP
/* B*/ ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP  ,LP
/* C*/ ,INCJ,DECJ,INCB,DECB,ADCM,SBCM,TSMA,CPMA,INCL,DECL,INCN,DECN,INB ,what,NOPT,what
/* D*/ ,SC  ,RC  ,SR  ,what,ANID,ORID,TSID,what,LEAVE,what,EXAB,EXAM,what,OUTB,what,OUTC
/* E*/ ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL
/* F*/ ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL ,CAL };


void executeInstruction()
{
    int iWaitLoop;

	// Execute l'instruction
    (*( instructions[ peekPC(PC) ]))();

    // Boucle de ralentissement entre chaque instruction
    for(iWaitLoop=0; iWaitLoop<=MaxDelay; iWaitLoop+=cycles);

    Horloge512 += cycles;
    Horloge002 += cycles;
    if (Horloge512 > MaxHorloge512) {
        Horloge512 = 0;
        isHorloge512 = 1;

    }

    if (Horloge002 > MaxHorloge002) {
        Horloge002 = 0;
        isHorloge002 = 1;
    }
}

/*
    Sauvegarde d'un fichier :
        - Saisie du nom de fichier (*.shp)
        - Ecriture du fichier octet par octet
*/
void sendByte(int byte)
{
    char *pch;
    int  ch;

    if(!isFileNameOut)
    {
        /* Tentative d'ouverture du fichier */
        if((fpOut=fopen(FileNameSAVE,"wb") ) != NULL)
        {
            isFileNameOut=1;
        }
    }

    if(isFileNameOut)
    {
        if(byte == 0x1A)
        {
            fclose(fpOut);
            isFileNameOut=0;
        }
        else
        {
            ch = byte;
            pch = (char*)&ch;
            fwrite(pch,1,1,fpOut);
            if(byte == 0x0D)
            {
                ch  = 0x0A;
                pch = (char*)&ch;
                fwrite(pch,1,1,fpOut);
            }
        }
    }
}

/* Fonction inconnue 72,73,76,77 */
void RZ() {
	set_Z0;
	PC++;
	cycles=2;
	}

/* Fonctions d'increments */
void INCI() { Q = regI; inc8bits(); PC++; cycles=4;}
void INCJ() { Q = regJ; inc8bits(); PC++; cycles=4;}
void INCA() { Q = regA; inc8bits(); PC++; cycles=4;}
void INCB() { Q = regB; inc8bits(); PC++; cycles=4;}
void INCK() { Q = regK; inc8bits(); PC++; cycles=4;}
void INCL() { Q = regL; inc8bits(); PC++; cycles=4;}
void INCM() { Q = regM; inc8bits(); PC++; cycles=4;}
void INCN() { Q = regN; inc8bits(); PC++; cycles=4;}

void DECI() { Q = regI; dec8bits(); PC++; cycles=4;}
void DECJ() { Q = regJ; dec8bits(); PC++; cycles=4;}
void DECA() { Q = regA; dec8bits(); PC++; cycles=4;}
void DECB() { Q = regB; dec8bits(); PC++; cycles=4;}
void DECK() { Q = regK; dec8bits(); PC++; cycles=4;}
void DECL() { Q = regL; dec8bits(); PC++; cycles=4;}
void DECM() { Q = regM; dec8bits(); PC++; cycles=4;}
void DECN() { Q = regN; dec8bits(); PC++; cycles=4;}
void INCP() { P++;      P &=0x7F;   PC++; cycles=2;}
void DECP() { P--;      P &=0x7F;   PC++; cycles=2;}

void IX()   {
	Q = regXH;
	DP= ++ram.x.X;
	PC++;
	cycles=6;
	}
void DX()   {
	Q = regXH;
	DP= --ram.x.X;
	PC++;
	cycles=6;
	}
void IY()   {
	Q = regYH;
	DP= ++ram.x.Y;
	PC++;
	cycles=6;
	}
void DY()   {
	Q = regYH;
	DP= --ram.x.Y;
	PC++;
	cycles=6;
	}

void IXL()  {
	Q = regXH;
	DP= ++ram.x.X;
	ram.h.A = peekDP(DP);
	PC++;
	cycles=7;
	}
void DYS()  {
	Q = regYH;
	DP= --ram.x.Y;
	pokePC(DP, ram.h.A);
	PC++;
	cycles=7;
	}
void DXL()  {
	Q = regXH;
	DP= --ram.x.X;
	ram.h.A = peekDP(DP);
	PC++;
	cycles=7;
	}
void IYS()  {
	Q = regYH;
	DP= ++ram.x.Y;
	pokePC(DP, ram.h.A);
	PC++;
	cycles=7;
	}

/* instructions de chargement simples */
void RA()   { ram.h.A = 0;          PC++; cycles=2;}
void LDD()  { ram.h.A = peekDP(DP); PC++; cycles=3;}
void LDM()  { ram.h.A = ram.M[P];   PC++; cycles=2;}
void LDP()  { ram.h.A = P;          PC++; cycles=2;}
void LDQ()  { ram.h.A = Q;          PC++; cycles=2;}
void LDR()  { ram.h.A = R;          PC++; cycles=2;}
void LIA()  { PC++; ram.h.A = peekPC(PC); PC++; cycles=4;}
void LIB()  { PC++; ram.h.B = peekPC(PC); PC++; cycles=4;}
void LIDL() { PC++;
	DP = (DP & 0xFF00L) | peekPC(PC);
	PC++;
	cycles=5;
	}
void LIDP() { PC++;
	DP = dpeekPC(PC);
	PC+=2;
	cycles=8;}
void LII()  { PC++; ram.h.I = peekPC(PC);  PC++; cycles=4;}
void LIJ()  { PC++; ram.h.J = peekPC(PC);  PC++; cycles=4;}
void LIP()  { PC++; P = peekPC(PC) & 0x7F; PC++; cycles=4;}
void LIQ()  { PC++; Q = peekPC(PC) & 0x7F; PC++; cycles=4;}
void LP()   {       P = peekPC(PC) & 0x7F; PC++; cycles=4;}

void STD()  { pokePC(DP, ram.h.A);  PC++; cycles=2;}
void STP()  { P = ram.h.A;          PC++; cycles=2;}
void STQ()  { Q = ram.h.A;          PC++; cycles=2;}
void STR()  { R = ram.h.A;          PC++; cycles=2;}


/* instructions de saut */
void JP()   { PC++; PC = dpeekPC(PC); cycles=6;}
void JRM()  { PC++; PC = PC - peekPC(PC); cycles=7;}
void JRP()  { PC++; PC = PC + peekPC(PC); cycles=7;}

void JPC()  { PC++; if(is_C1) PC = dpeekPC(PC); else PC+=2; cycles=6;}
void JPZ()  { PC++; if(is_Z1) PC = dpeekPC(PC); else PC+=2; cycles=6;}
void JPNC() { PC++; if(is_C0) PC = dpeekPC(PC); else PC+=2; cycles=6;}
void JPNZ() { PC++; if(is_Z0) PC = dpeekPC(PC); else PC+=2; cycles=6;}


void JRCM() { PC++; if(is_C1)
                    { PC = PC - peekPC(PC); cycles=7;}
                    else { PC++; cycles=4;}
            }
void JRCP() { PC++; if(is_C1)
                    { PC = PC + peekPC(PC); cycles=7;}
                    else { PC++; cycles=4;}
            }
void JRNCM(){ PC++; if(is_C0)
                    { PC = PC - peekPC(PC); cycles=7;}
                    else { PC++; cycles=4;}
            }
void JRNCP(){ PC++; if(is_C0)
                    { PC = PC + peekPC(PC); cycles=7;}
                    else { PC++; cycles=4;}
            }

void JRZM() { PC++; if(is_Z1)
                    { PC = PC - peekPC(PC); cycles=7;}
                    else { PC++; cycles=4;}

            }

void JRZP() { PC++; if(is_Z1)
                    { PC = PC + peekPC(PC); cycles=7;}
                    else { PC++; cycles=4;}
            }
void JRNZM(){ PC++; if(is_Z0)
                    { PC = PC - peekPC(PC); cycles=7;}
                    else { PC++; cycles=4;}
            }

void JRNZP(){ PC++; if(is_Z0)
                    { PC = PC + peekPC(PC); cycles=7;}
                    else { PC++; cycles=4;}
            }

/* instruction de pile */
void POP() { ram.h.A = ram.M[R++];          PC++; cycles=2;}
void PUSH(){ R--; ram.M[R] = ram.h.A ;      PC++; cycles=3;}
void RTN() { PC = ram.M[R+1]<<8 | ram.M[R]; R+=2; cycles=4;}
void CAL() {
    R--; ram.M[R] = (unsigned char)(((PC + 2) & 0xFF00)>>8);
    R--; ram.M[R] = (unsigned char) ((PC + 2) & 0xFF);
    PC = (peekPC(PC) & 0x1F)<<8 | peekPC(PC+1);
    cycles=7;
    }

void CALL() {
    R--; ram.M[R] = (unsigned char)(((PC + 3) & 0xFF00)>>8);
    R--; ram.M[R] = (unsigned char) ((PC + 3) & 0xFF);
    PC = dpeekPC(PC+1);
    cycles=8;
    }

void LEAVE(){ ram.M[R]=0; PC++; cycles=2;}
void LOOP() {
    PC++;
    ram.M[R]--;
    if(ram.M[R]==0xFF) { flags = set_C1_Z0; R++; PC++; cycles=7; }
    else {
        if(ram.M[R]!=0) flags = set_C0_Z0; else flags = set_C0_Z1;
        PC = PC - peekPC(PC);
        cycles=10;
    }
}

/* instruction NOP */
void NOPW(){ PC++; cycles=2;}
void NOPT(){ PC++; cycles=3;}
void WAIT(){ PC++; cycles= 6 + peekPC(PC++);}
void WAITI(){  P = regI; cycles= 5 + ram.h.I<<2; flags = set_Z1; PC++; }

/* instruction de manipulation de bit */
void RC()  { flags = set_C0_Z1; PC++; cycles=2;}
void SC()  { flags = set_C1_Z1; PC++; cycles=2;}
void SL()  {
    int C;
    C = ram.h.A & 0x80;
    ram.h.A = ram.h.A <<1;
    if( is_C1 ) ram.h.A |= 0x01;
    if( ram.h.A != 0 ) flags = set_Z0; else flags = set_Z1;
    if( C != 0 )       flags = set_C1; else flags = set_C0;
    PC++;
    cycles=2;
}
void SR()  {
    int C;
    C = ram.h.A & 0x01;
    ram.h.A = ram.h.A >>1;
    if( is_C1 ) ram.h.A |= 0x80;
    if( ram.h.A !=0 ) flags = set_Z0; else flags = set_Z1;
    if( C != 0 )      flags = set_C1; else flags = set_C0;
    PC++;
    cycles=2;
}
void SWP() { ram.h.A = (ram.h.A>>4) | (ram.h.A<<4); PC++; cycles=2;}




/* Fonctions d'echange memoire */
void EXAB() {
    unsigned char tmp;
    tmp = ram.h.A;
    ram.h.A = ram.M[regB];
    ram.M[regB] = tmp;
    PC++;
    cycles=3;
    }

void EXAM() {
    unsigned char tmp;
    tmp = ram.h.A;
    ram.h.A = ram.M[P];
    ram.M[P] = tmp;
    PC++;
    cycles=3;
    }

void EXW() {
    unsigned char tmp;
    D = ram.h.I;
    cycles= 6 + D + D<<1; /* = 6 +3D*/
    do {
        tmp = ram.M[P];
        ram.M[P++] = ram.M[Q];
        ram.M[Q++] = tmp;
        P = P & 0x7F;
        Q = Q & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void EXB() {
    unsigned char tmp;
    D = ram.h.J;
    cycles= 6 + D + D<<1; /* = 6 +3D*/
    do {
        tmp = ram.M[P];
        ram.M[P++] = ram.M[Q];
        ram.M[Q++] = tmp;
        P = P & 0x7F;
        Q = Q & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void EXWD(){
    unsigned char tmp;
    D = ram.h.I;
    cycles= 7 + 6*D;
    do {
        tmp = ram.M[P];
        ram.M[P++] = peekDP(DP);
        pokePC(DP, tmp);
        P = P & 0x7F;
        DP++;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void EXBD(){
    unsigned char tmp;
    D = ram.h.J;
    cycles= 7 + 6*D;
    do {
        tmp = ram.M[P];
        ram.M[P++] = peekDP(DP);
        pokePC(DP, tmp);
        P = P & 0x7F;
        DP++;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

/* fonction de deplacement memoire */
void FILM() {
    unsigned char tmp;
    tmp = ram.h.A;
    D = ram.h.I;
    cycles= 5 + D;
    do {
        ram.M[P++] = tmp;
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void FILD() {
    unsigned char tmp;
    tmp = ram.h.A;
    D = ram.h.I;
    cycles= 4 + D + D<<1; /* = 4 +3D*/
    do {
        pokePC(DP++, tmp);
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void MVW() {
    D = ram.h.I;
    cycles= 5 + D<<1;
    do {
        ram.M[P++] = ram.M[Q++];
        P = P & 0x7F;
        Q = Q & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void MVB() {
    D = ram.h.J;
    cycles= 5 + D<<1;
    do {
        ram.M[P++] = ram.M[Q++];
        P = P & 0x7F;
        Q = Q & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void MVWD(){
    D = ram.h.I;
    cycles= 5 + D<<2;
    do {
        ram.M[P++] = peekDP(DP++);
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void MVBD(){
    D = ram.h.J;
    cycles= 5 + D<<2;
    do {
        ram.M[P++] = peekDP(DP++);
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void DATA(){
    unsigned int adr;
    adr = ram.x.BA;
    D = ram.h.I;
    cycles= 11 + D<<1;
    do {
        ram.M[P++] = peekPC(adr++);
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void MVDM() {
    pokePC(DP, ram.M[P]);
    PC++;
    cycles=3;
    }

void MVMD() {
    ram.M[P] =  peekDP(DP);
    PC++;
    cycles=3;
    }


/* fonctions I/O */
void OUTA() { Q = 0x5C; IA = ram.M[regIA]; PC++; cycles=3;}
void OUTB() { Q = 0x5D;
    IB = ram.M[regIB];
    // Gestion de l'interface serie
    if(IB & 0x02) {
        /* Request to Send */
        IB |= 0x10; /* set Clear to Send = 1 */
    }
//  else
//      IB &= 0xEF; /* set Clear to Send = 0 */
    PC++;
    cycles=3;
    }
void OUTF() {

    int bit;

    IF = ram.M[regIF];
    Q = 0x5E;

    // Gestion de l'interface serie
    if(IF & 0x08)   bit =1;
    else            bit =0;

    if(IB & 0x10) { /* Clear to Send ? */

        if(!IOByteOutCpt)
            /* attente du bit start */
            if (bit!=0) {
                isIOByteOut= 1;
                IOByteOutCpt++;
            }
            else isIOByteOut= 0;
        else
        if(IOByteOutCpt<9) {
            /* Send Data */
            /* NB: les bits de donnees sont inverses (1-bit) */
            IOByteOut = (IOByteOut>>1) | ((1-bit)<<7);
            IOByteOutCpt++;
            if(IOByteOutCpt==9) {
                sendByte(IOByteOut);
                isIOByteOut = 0;
                IOByteOutCpt=0;
            }

        }
    }
    else {
        if(isIOByteOut) sendByte(IOByteOut);
        isIOByteOut = 0;
    }
    PC++;
    cycles=3;
    }


void OUTC() {
    Q = 0x5F;
    IC = ram.M[regIC]; PC++;

    ScreenON = (IC & 1);
    if( ScreenON ) {
        isEmulateurMsg = 1;  //= PrintScreen
    }
/*    else {
        // Gestion artificielle du sigle busy
        if (MemoryBuffer[0x703D] & 0x01) {
            MemoryBuffer[0x703D] |= 0x01;
            isEmulateurMsg = 1;  //= PrintScreen
        }
    }
*/
    if (IC & 2) {
        Horloge512 = Horloge002 = 0;
        isHorloge512 = isHorloge002 = 0;
    }
    /* arret de l'horloge si null */
    CLK = (IC & 4);
    /*
    if( (IC & 8) ) {
        // Power off
    }
    */
    cycles=3;
}

void INA()  {

    ram.h.A = GetPortA(IA);
    if(!ram.h.A) flags = set_Z1;
    else flags = set_Z0;
    PC++;
    cycles=2;
    }


void INB()  {
/*
    cette instruction est surtout utilisee pour la lecture d'octets
	dans l'instruction LOAD
*/
    int numread;
    char BufferIn[2]; // tampon de lecture
    char byte;

    IB |= 0x10; /* set Clear to Send = 1 */

    // si instruction LOAD, alors emuler la porteuse :
    if(PC==0xF10F)
    {
        IB |= 0x20;
        if (!isFileNameIn)
        {

            /* Tentative d'ouverture du fichier */
            if((fpIn=fopen(FileNameLOAD,"rb")) != NULL)
            {
                isFileNameIn=1;
            }
            else
            {
                isFileNameIn=0;
            }
        }
    }

    if(PC==0xEC3B)
    {
        /*
            on se trouve au milieu de la routine de lecture des octets du fichier ouvert
            - ignore cette routine
            - renvoie B = octet lu
            - si l'octet est une fin de ligne, ram.0E |= 80;
            - si l'octet est une fin de fichier, ram.0E |= 40;
        */
        // saute a la fin du sous-programme dans la ROM Basic
            PC = 0xED11;
            P = 0x0E;
            // lecture d'un octet
            if(fpIn!=NULL)
                numread = fread( BufferIn, 1, 1, fpIn);
            else numread=0;
            if(!numread) byte = 0x1A;
            else byte = BufferIn[0];

            // on saute le caractere '\r'
            if(byte == 0x0A)
            {
                if(fpIn!=NULL)
                    numread = fread( BufferIn, sizeof( char ), 1, fpIn);
                else numread=0;
                if(!numread) byte = 0x1A;
                else byte = BufferIn[0];
            }

            // Gestion de la fin de ligne '\n'
            if(byte == 0x0D) ram.M[P] |= 0x40; // fin de ligne

            // Getion de la fin de fichier
            if(byte == 0x1A)
            {
                if(fpIn!=NULL)
                    fclose(fpIn);
                isFileNameIn=0;
                ram.M[P] |= 0x80; // fin de fichier
            }
            ram.h.B = byte;
    }

    ram.h.A = IB;
    if(!ram.h.A) flags = set_Z1; else flags = set_Z0; PC++; cycles=2;
}


void TEST()
{
    unsigned char tmp;
    set_Z0;
    PC++;
    tmp = peekPC(PC);

    /* Test 01 (500 ms ) */
    if(tmp==0x01)
        if(isHorloge512)
            {
            Horloge512 = 0;
            isHorloge512 = 0;
            flags = set_Z0;
            }
        else
            {
            flags = set_Z1;
            }

    /* Test 02 (002 ms ) */
    if(tmp==0x02)
    {
        if(isHorloge002)
        {
            Horloge002 = 0;
            isHorloge002 = 0;
            flags = set_Z0;
        }
        else
            flags = set_Z1;
    }
    /* test sur BRK */
    if(tmp==0x08)
    {
        GestionKeyboard();
        if (!BreakOn) flags = set_Z1;
        else
        flags = set_Z0; /* stop */
    }
    PC++;
    cycles=4;
}

/* fonctions logiques et aritm. */
void ADIA() {
    int tmp;
    PC++;
    tmp = ram.h.A + peekPC(PC);
    if(!tmp)  flags = set_Z1; else flags = set_Z0;
    if(tmp<256) flags = set_C0; else flags = set_C1;
    ram.h.A = tmp & 255;
    PC++;
    cycles=4;
    }

void ADIM() {
    int tmp;
    PC++;
    tmp = ram.M[P] + peekPC(PC);
    if(!tmp)  flags = set_Z1; else flags = set_Z0;
    if(tmp<256) flags = set_C0; else flags = set_C1;
    ram.M[P] = tmp & 255;
    PC++;
    cycles=4;
    }
void ADM() {
    int tmp;
    tmp = ram.M[P] + ram.h.A;
    if(!tmp)  flags = set_Z1; else flags = set_Z0;
    if(tmp<256) flags = set_C0; else flags = set_C1;
    ram.M[P] = tmp & 255;
    PC++;
    cycles=3;
    }

void ADCM() {
    int tmp;
    tmp = ram.M[P] + ram.h.A;
    if(is_C1) tmp++;
    if(!tmp)  flags = set_Z1; else flags = set_Z0;
    if(tmp<256) flags = set_C0; else flags = set_C1;
    ram.M[P] = tmp & 255;
    PC++;
    cycles=3;
    }

void SBIA() {
    int tmp,a;
    PC++;
    tmp = ram.h.A;
    a = peekPC(PC);
    if(tmp < a)
        {
        if(a) flags = set_C1;
        }
    else flags = set_C0;
    tmp -= a;
    if(!tmp) flags = set_Z1; else flags = set_Z0;
    ram.h.A = tmp & 255;
    PC++;
    cycles=4;
    }

void SBIM() {
    int tmp, a;
    PC++;
    tmp = ram.M[P];
    a = peekPC(PC);
    if(tmp < a)
        {
        if (a) flags = set_C1;
        }
    else flags = set_C0;
    tmp -= a;
    if(!tmp)  flags = set_Z1; else flags = set_Z0;
    ram.M[P] = tmp & 255;
    PC++;
    cycles=4;
    }
void SBM() {
    int tmp;
    tmp = ram.M[P];
    if(tmp < ram.h.A)
        {
        if (ram.h.A) flags = set_C1;
        }
    else flags = set_C0;
    tmp -= ram.h.A;
    if(!tmp)  flags = set_Z1; else flags = set_Z0;
    ram.M[P] = tmp & 255;
    PC++;
    cycles=3;
    }

void SBCM() {
    int tmp;
    tmp = ram.M[P];
    if(is_C1) tmp--;
    if(tmp < ram.h.A)
        {
        if (ram.h.A) flags = set_C1;
        }
    else flags = set_C0;
    tmp -= ram.h.A;
    if(!tmp)  flags = set_Z1; else flags = set_Z0;
    ram.M[P] = tmp & 255;
    PC++;
    cycles=3;
    }


void ANIA() {
    PC++;
    if( !(ram.h.A &= peekPC(PC)) ) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=4;
    }
void ORIA() {
    PC++;
    if( !(ram.h.A |= peekPC(PC)) ) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=4;
    }
void TSIA() {
    PC++;
    if( !(ram.h.A & peekPC(PC)) )  flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=4;
    }
void CPIA() {
    int tmp;
    PC++;
    if(!(tmp=ram.h.A -peekPC(PC))) flags = set_Z1; else flags = set_Z0;
    if( tmp < 0 )                  flags = set_C1; else flags = set_C0;
    PC++;
    cycles=4;
    }


void ANIM() {
    PC++;
    if( !(ram.M[P] &= peekPC(PC))) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=4;
    }
void ORIM() {
    PC++;
    if( !(ram.M[P] |= peekPC(PC)) ) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=4;
    }
void TSIM() {
    PC++;
    if( !(ram.M[P] & peekPC(PC)) )  flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=4;
    }
void CPIM() {
    int tmp;
    PC++;
    if(!(tmp=ram.M[P]-peekPC(PC))) flags = set_Z1; else flags = set_Z0;
    if( tmp < 0 )                  flags = set_C1; else flags = set_C0;
    PC++;
    cycles=4;
    }

void ANMA(){
    if( !(ram.M[P] &= ram.h.A  ) ) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=3;
    }
void ORMA(){
    if( !(ram.M[P] |= ram.h.A  ) ) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=3;
    }
void TSMA() {
    if( !(ram.h.A  & ram.M[P] )  ) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=3;
    }
void CPMA() {
    int tmp;
    if(!(tmp=ram.M[P] - ram.h.A )) flags = set_Z1; else flags = set_Z0;
    if( tmp < 0 )                  flags = set_C1; else flags = set_C0;
    PC++;
    cycles=3;
    }

void ANID() {
    unsigned char tmp;
    PC++;
    tmp = peekDP(DP) & peekPC(PC);
    pokePC(DP, tmp);
    if( !tmp) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=6;
    }
void ORID() {
    unsigned char tmp;
    PC++;
    tmp = peekDP(DP) | peekPC(PC);
    pokePC(DP, tmp);
    if( !tmp ) flags = set_Z1; else flags = set_Z0;
    PC++;
    cycles=6;
    }

void TSID() {
    PC++;
    if( !(peekDP(DP)& peekPC(PC)) )  flags = set_Z1;
	else flags = set_Z0;
    PC++;
    cycles=6;
    }

/* fonctions aritm. sur blocs */
void ADN() {
    unsigned char a, m,isZero;
    int dcb;

    isZero =0;
    a = ram.h.A;
    a = dcbTableH[a>>4] + (a & 0x0F);
    D = ram.h.I;
    cycles=7 + D + D<<1;
    do {
        m = ram.M[P];
        m = dcbTableH[m>>4] + (m & 0x0F);
        dcb = m + a;
        if(dcb > 99) {
            m = dcb - 100;
            a = 1;
        }
        else {
            m = dcb & 0xFF;
            a = 0;
        }
        m = dcbTableByte[m];
        isZero |= m;
        ram.M[P--] = m;
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    if (!isZero) flags = set_Z1; else flags = set_Z0;
    if (!a) flags = set_C0; else flags = set_C1;
    PC++;
    }

void SBN() {
    unsigned char a,m,isZero;

    isZero =0;
    a = ram.h.A;
    a = dcbTableH[a>>4] + (a & 0x0F);
    D = ram.h.I;
    cycles=7 + D + D<<1;
    do {
        m = ram.M[P];
        m = dcbTableH[m>>4] + (m & 0x0F);
        if(m < a) {
            m = 100 + (m - a);
            a = 1;
        }
        else {
            m = m - a;
            a = 0;
        }
        m = dcbTableByte[m];
        isZero |= m;
        ram.M[P--] = m;
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    if (!isZero) flags = set_Z1; else flags = set_Z0;
    if (!a) flags = set_C0; else flags = set_C1;
    PC++;
    }

void ADW() {
    unsigned char a, m,isZero;
    int dcb;

    isZero =0;
    a = 0;
    D = ram.h.I;
    cycles=7 + D + D<<1;
    do {
        m = ram.M[Q--];
        a = dcbTableH[m>>4] + (m & 0x0F) + a;
        m = ram.M[P];
        m = dcbTableH[m>>4] + (m & 0x0F);
        dcb = m + a;
        if(dcb > 99) {
            m = dcb - 100;
            a = 1;
        }
        else {
            m = dcb & 0xFF;
            a = 0;
        }
        m = dcbTableByte[m];
        isZero |= m;
        ram.M[P--] = m;
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    if (!isZero) flags = set_Z1; else flags = set_Z0;
    if (!a) flags = set_C0; else flags = set_C1;
    PC++;
    }

void SBW() {
    unsigned char a,m,isZero;

    isZero =0;
    a = 0;
    D = ram.h.I;
    cycles=7 + D + D<<1;
    do {
        m = ram.M[Q--];
        a = dcbTableH[m>>4] + (m & 0x0F) + a;
        m = ram.M[P];
        m = dcbTableH[m>>4] + (m & 0x0F);
        if(m < a) {
            m = 100 + (m - a);
            a = 1;
        }
        else {
            m = m - a;
            a = 0;
        }
        m = dcbTableByte[m];
        isZero |= m;
        ram.M[P--] = m;
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    if (!isZero) flags = set_Z1; else flags = set_Z0;
    if (!a) flags = set_C0; else flags = set_C1;
    PC++;
    }

void ADB() {
    long tmp;
    unsigned int res;
    tmp = (ram.M[P] | ram.M[P+1]<<8 ) + ram.x.BA;
    if(tmp > 0xFFFF) flags = set_C1; else flags = set_C0;
    res = (unsigned int) tmp & 0xFFFF;
    if(!res ) flags = set_Z1; else flags = set_Z0;
    ram.M[P++] = res & 0xFF;
    P = P & 0x7F;
    ram.M[P] = res>>8;
    PC++;
    cycles=5;
}

void SBB() {
    unsigned int tmp;
    unsigned int res;
    tmp = (ram.M[P] | ram.M[P+1]<<8);
    if(tmp < ram.x.BA)
        {
        flags = set_C1;
        }
    else flags = set_C0;
    res = (unsigned int) (tmp - ram.x.BA) & 0xFFFF;
    if(!res ) flags = set_Z1; else flags = set_Z0;
    ram.M[P++] = res & 0xFF;
    P = P & 0x7F;
    ram.M[P] = res>>8;
    PC++;
    cycles=5;
}

void SRW() {
    int tmp;
    D = ram.h.I;
    cycles=5 + D;
    tmp = 0;
    do {
        tmp = ram.M[P] | ((tmp & 0x000F)<<8) ;
        ram.M[P++] = tmp>>4;
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

/* instructions non documentees */
void READA() { PC++; ram.h.A = peekPC(PC); cycles=3;}
void READM() { PC++; ram.M[P]= peekPC(PC); cycles=3;}

void SLW() {
    int tmp;
    D = ram.h.I;
    cycles=5 + D;
    tmp = 0;
    do {
        tmp = ram.M[P]<<4 | (tmp>>8);
        ram.M[P--] = tmp & 0xFF;
        P = P & 0x7F;
        D--;
    }
    while (D != 0xFF);
    PC++;
    }

void PTJ() {
    PC++;
    DTJcompter = peekPC(PC);
    PC++;
    R--; ram.M[R] = peekPC(PC++);
    R--; ram.M[R] = peekPC(PC++);
    cycles=9;
    }

void DTJ()  {
    /* Pour cette instruction, la duree
    en cyles est estimee, faute de doc ! */

    unsigned char byte,a;
    a = ram.h.A;
    PC++;
    cycles=2;
    do {
        DTJcompter--;
        byte = peekPC(PC++);
        if(a!=byte) {
            PC+=2;
            cycles+=3;
            flags = set_C0_Z1;
            }
        else {
            PC = dpeekPC(PC);
            cycles+=4;
            flags = set_C0_Z1;
            return;
        }
    }
    while( DTJcompter != 0 );
    PC = dpeekPC(PC);
    cycles+=2;
    flags = set_C0_Z1;
}


/* Cette fonction n'existe pas dans le jeu de Sharp.
   Je l'ai inventee pour des raisons de debogage.
   Elle peut servir pour generer une interruption.
   Actuellement elle remplace une instruction LIA()
   dans la ROM du Sharp.
   Je n'ai effectu qu'un seul remplacement,
   mais j'ai oubli o !!
*/
void INTx() {
    LIA(); /* execution de la commande normale */
}
